/*********************************************
Project : Commande du Vigipark (TP1)
Version : 1
Mise  jour: 18/11/2009
Author  : Philippe Mariano                
Company : LYCEE Pierre Emile MARTIN       
Comments: Simulation sur la carte SSI
	  Le bras descend tant que BP UHF est appuy
Chip type           : ATMEGA8535
Clock frequency     : 8,000000 MHz
Memory model        : Small
Internal SRAM size  : 512
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <mega8535.h>

// Bibliothques non gnres par Wizard (rajoutes manuellement) 
// -----------------------------------------------------------------------------------------------------     
#include <ssi.h>      // contient les fonctions Lire_BP, Affiche_LCD
#include <delay.h>    // contient la fonction delay_ms
#include <stdio.h>    // contient la fonction sprintf

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>

// =====================================================================================================
// Programme principal
// =====================================================================================================
void main(void)
{  // Dbut prog principal
// Declare your local variables here
// -----------------------------------------------------------------------------------------------------
// type 	nom              		Description
// -----------------------------------------------------------------------------------------------------
char display_buffer_ligne0[17]; 	// tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	// tampon ligne 1 de l'afficheur
unsigned char Aff=0, Aff_1=0;
unsigned char BP_UHF, Moteur; 
// -----------------------------------------------------------------------------------------------------

// -----------------------------------------------------------------------------------------------------
// Configuration des ports d'entre / sortie
// Port A initialization
PORTA=0x3F; 		// ne pas modifier cette valeur
DDRA=????;  					// <-  COMPLETER

// Port B initialization
PORTB=0x00;             // ne pas modifier cette valeur
DDRB=????;              			// <-  COMPLETER
// -----------------------------------------------------------------------------------------------------

// LCD module initialization
lcd_init(16);

// --------------------------------------- Message d'accueil -------------------------------------------
sprintf(display_buffer_ligne0,"  TP1 VIGIPARK  ");
sprintf(display_buffer_ligne1,"   SIMULATION   ");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
delay_ms(3000);       
// -----------------------------------------------------------------------------------------------------

sprintf(display_buffer_ligne0," PROG DESCENDRE "); 


while(1)
  { // Dbut xhile
//-------------------------------------------------------------------------------------------------------
// ATTENTION, sur la carte SSI l'tat logique actif des BP est 0 
// Appuyer sur le BP DEC pour simuler la descente du bras
//-------------------------------------------------------------------------------------------------------
    BP_UHF = (PINA & ????);    			// <-  COMPLETER
    if (BP_UHF == ????)   			// <-  COMPLETER
 	 Moteur=0x02;
     else Moteur = 0x00;
    PORTB = ?????;                             // <-  COMPLETER
 
 // --------------------------------- Gestion de l'affichage -------------------------------------------
       if(BP_UHF==0){sprintf(display_buffer_ligne1,"Descente du bras");Aff=0;} 
       else {sprintf(display_buffer_ligne1,"  Arret Moteur  ");Aff=1;}
       
       if (Aff != Aff_1) {Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);Aff_1=Aff;}
  }; // Fin xhile
} // fin main